package Enigmatic::Plugboard;
use DAKKAR::p 'class';
use Enigmatic::Types qw(PlugWiringMap Letter);

has wiring => (
    is => 'ro',
    isa => PlugWiringMap,
    coerce => 1,
    builder => '_build_wiring',
);

sub _build_wiring {
    my %map = map { $_, $_ } 'A'..'Z';
    return \%map;
}

with 'Enigmatic::Role::WithWiring';

sub map {
    my $self = shift;
    my ($letter) = pos_validated_list(
        \@_,
        { isa => Letter },
    );

    return $self->wiring->at($letter);
}
